local assets =
{
    Asset("ANIM", "anim/realnightsword.zip"),
    Asset("ANIM", "anim/swap_realnightsword.zip"),

}

local function FackSword(inst)
    if inst.components.weapon ~= nil then
        inst:RemoveComponent("weapon")
    end
    local owner = inst.components.inventoryitem.owner or nil
    if owner ~= nil then
      owner.AnimState:Hide("ARM_carry")
      owner.AnimState:Show("ARM_normal")
    end
    -- inst.components.weapon:SetDamage(10)
    -- if inst.components.moisture or inst.components.poisonable then
    inst.components.equippable.dapperness = 0
    -- else
    inst:AddComponent("dapperness")
    inst.components.dapperness.dapperness = 0
    -- end
    -- local owner = inst.components.inventoryitem.owner or nil
    if owner ~= nil and inst.components.equippable:IsEquipped() then
        if TUNING.LANGA == 0 then
            owner.components.talker:Say("这把刀变得普通了.")
        else
            owner.components.talker:Say("The Sword became dull.")
        end
    end
end

local function onfuelupdate(inst)
    if inst.components.fueled ~= nil then
      inst.components.fueled.bonusmult = 1/3
    end
    local owner = inst.components.inventoryitem.owner or nil
    if not inst.components.fueled:IsEmpty() and inst.components.weapon == nil then
      inst:AddComponent("weapon")
    end
    if inst.components.weapon ~= nil then
      inst.components.weapon:SetDamage(17 * (3 + 1.5 * math.max(0,math.min(1,inst.components.fueled:GetPercent()))))
    end
    -- inst.components.fueled:SetPercent(math.max(0,math.min(1,inst.components.fueled:GetPercent())))
    inst.components.equippable.dapperness = -(1/6 * (1+math.max(0,math.min(1,inst.components.fueled:GetPercent()))))
    inst.components.dapperness.dapperness = -(1/6 * (1+math.max(0,math.min(1,inst.components.fueled:GetPercent()))))

    -- if owner ~= nil and not inst.components.fueled:IsEmpty() then
    --   inst.components.fuled:StartConsuming()
    -- elseif
    --   inst.components.fuled:StopConsuming()
    -- end
    if not inst.components.fueled:IsEmpty() and inst.components.equippable:IsEquipped() then
      if owner ~= nil then
        owner.AnimState:OverrideSymbol("swap_object", "swap_realnightsword", "swap_machete")
        owner.AnimState:Show("ARM_carry")
        owner.AnimState:Hide("ARM_normal")
      end
      inst.components.fueled:StartConsuming()
    elseif not inst.components.fueled:IsEmpty() and not inst.components.equippable:IsEquipped() then
      inst.components.fueled:StopConsuming()
    elseif inst.components.fueled:IsEmpty() then
      inst.components.fueled:StopConsuming()
      FackSword(inst)
    end
end

local function onequip(inst, owner)
    if not inst.components.fueled:IsEmpty() and inst.components.fueled ~= nil then
      inst.components.fueled:StartConsuming()
    end
    owner.AnimState:OverrideSymbol("swap_object", "swap_realnightsword", "swap_machete")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    onfuelupdate(inst)
end

local function onunequip(inst, owner)
    if not inst.components.fueled:IsEmpty() then
      inst.components.fueled:StopConsuming()
    end
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
    onfuelupdate(inst)
end

local function ondropped(inst)
    if not inst.components.fueled:IsEmpty() then
      inst.components.fueled:StopConsuming()
    end
    onfuelupdate(inst)
end

-- local function update( inst )
--     inst.components.weapon:SetDamage(17 * (3.5 + math.max(0,math.min(1,inst.components.finiteuses:GetPercent()))))
--     inst.components.finiteuses:SetPercent(math.max(0,math.min(1,inst.components.finiteuses:GetPercent())))
--     -- if inst.components.moisture or inst.components.poisonable then
--     inst.components.equippable.dapperness = -(1/6 * (1+math.max(0,math.min(1,inst.components.finiteuses:GetPercent()))))
--     -- else
--     --   inst:AddComponent("dapperness")
--     inst.components.dapperness.dapperness = -(1/6 * (1+math.max(0,math.min(1,inst.components.finiteuses:GetPercent()))))
--     -- end
-- end

-- local function onAttack( inst, attacker, target)
--     if attacker and attacker.components.sanity then
--       if inst.components.finiteuses:GetPercent() > 0 then
--         -- attacker.components.sanity:DoDelta(-0.1 * ( inst.components.finiteuses:GetPercent()))
--       end
--     end
-- end
-- local function ShouldAcceptItem( inst, item)
--     local owner = item.components.inventoryitem:GetGrandOwner()
--     if item.prefab == "nightmarefuel" then
--         if inst.components.finiteuses:GetPercent() < 1 then
--         return true
--         else
--             if TUNING.LANGA == 0 then
--                 owner.components.talker:Say("这把刀已经修好了！")
--             else
--                 owner.components.talker:Say("It's sharp enough now!")
--             end
--             return false
--         end
--     -- elseif item.prefab == "nightmare_darkgem" then
--     --     if inst.level < 2 then
--     --         if TUNING.LANGA == 0 then
--     --             owner.components.talker:Say("它好像更加邪恶了！")
--     --         else
--     --             owner.components.talker:Say("It became darker.")
--     --         end
--     --         return true
--     --     else
--     --         if TUNING.LANGA == 0 then
--     --             owner.components.talker:Say("这把刀已经不能再升级了！")
--     --         else
--     --             owner.components.talker:Say("It can't upgrade anymore!")
--     --         end
--     --         return false
--     --     end
--     -- elseif item.prefab == "nightmare_lightgem" then
--         -- if inst.level > 0 then
--         --     if TUNING.LANGA == 0 then
--         --         owner.components.talker:Say("它好像更加洁净了！")
--         --     else
--         --         owner.components.talker:Say("It became cleaner.")
--         --     end
--         --     return true
--         -- else
--         --     if TUNING.LANGA == 0 then
--         --         owner.components.talker:Say("这把刀已经不能再降级了！")
--         --     else
--         --         owner.components.talker:Say("It can't degrade anymore!")
--         --     end
--         --     return false
--         -- end
--     else
--         if TUNING.LANGA == 0 then
--             owner.components.talker:Say("这玩意儿不能拿来修刀！")
--         else
--             owner.components.talker:Say("Can't repair with this.")
--         end
--     end
--     return false
-- end

-- local function OnGetItemFromPlayer( inst, giver, item )
--     -- if item.prefab == "nightmare_darkgem" then
--     --     if inst.level < 2 then
--     --         inst.level = inst.level + 1
--     --     end
--     --     update(inst)
--     --     inst.components.finiteuses:SetUses(maxUsesNow)
--     --     return
--     -- elseif item.prefab == "nightmare_lightgem" then
--     --     if inst.level > 0 then
--     --         inst.level = inst.level - 1
--     --     end
--     --     update(inst)
--     --     inst.components.finiteuses:SetUses(maxUsesNow)
--     --     return
--     -- end
--     inst.components.finiteuses:SetUses(math.min(100,(inst.components.finiteuses:GetUses()+25)))
--     inst.components.finiteuses:SetPercent(math.max(0,math.min(1,inst.components.finiteuses:GetPercent())))
--     update(inst)
--     inst.SoundEmitter:PlaySound("dontstarve/common/nightmareAddFuel")
-- end

-- local function onUseChange( inst, data )
--     if data.percent > 1 then
--         inst.components.finiteuses:SetUses(100)
--         inst.components.finiteuses:SetPercent(1)
--     elseif data.percent < 0 then
--         inst.components.finiteuses:SetUses(0)
--         inst.components.finiteuses:SetPercent(0)
--         data.percent = 0
--     end
--     if data.percent > 0 and data.percent <= 1 then
--       inst.components.weapon:SetDamage(17 * (3.5 + data.percent))
--       -- if inst.components.moisture or inst.components.poisonable then
--       inst.components.equippable.dapperness = -(1/6 *( 1 + data.percent))
--       -- else
--       inst:AddComponent("dapperness")
--       inst.components.dapperness.dapperness = -(1/6 *( 1 + data.percent))
--       -- end
--     end

--     if data.percent == 0 then
--       FackSword(inst)
--     end

-- end

-- local function onload(inst, data)
--   if data then
--     if data.level then
--       inst.level = data.level
--       onfuelupdate(inst)
--     end
--   end
-- end

-- local function onsave(inst, data)
--   data.level = inst.level
-- end

local function fn(sim)
  local inst = CreateEntity()
  local trans = inst.entity:AddTransform()
  local anim = inst.entity:AddAnimState()

  MakeInventoryPhysics(inst)
  if SaveGameIndex:IsModeShipwrecked() or inst.components.poisonable then
      MakeInventoryFloatable(inst, "idle_water", "anim")
  end


  inst.AnimState:SetBank("realnightsword")
  inst.AnimState:SetBuild("realnightsword")
  inst.AnimState:PlayAnimation("idle")
  inst.AnimState:SetMultColour(1, 1, 1, 0.6)

  inst:AddTag("shadow")
  inst:AddTag("sharp")

  inst:AddComponent("weapon")
  inst.components.weapon:SetDamage(76.5)

  -- inst.components.weapon:SetOnAttack(onAttack)

  inst:AddComponent("inspectable")

  -- inst:AddComponent("trader")
  -- inst.components.trader.acceptnontradable = true
  -- inst.components.trader.onaccept = OnGetItemFromPlayer
  -- inst.components.trader:SetAcceptTest(ShouldAcceptItem)

  -- inst:ListenForEvent("percentusedchange", onUseChange)

  inst:AddComponent("inventoryitem")
  inst.components.inventoryitem.imagename = "realnightsword"
  inst.components.inventoryitem.atlasname = "images/inventoryimages/realnightsword.xml"
  inst.components.inventoryitem:SetOnDroppedFn( ondropped )

  inst:AddComponent("equippable")
  inst.components.equippable:SetOnEquip(onequip)
  inst.components.equippable:SetOnUnequip(onunequip)
  inst.components.inventoryitem.keepondeath = false

  -- inst:AddComponent("finiteuses")
  -- inst.components.finiteuses:SetMaxUses(100)
  -- inst.components.finiteuses:SetUses(100)
  -- inst.components.finiteuses:SetPercent(1)

  inst:AddComponent("fueled")
  inst.components.fueled.maxfuel = 240
  inst.components.fueled.accepting = true
  inst.components.fueled.rate = 1
  inst.components.fueled.bonusmult = 1/3
  inst.components.fueled.fueltype = "NIGHTMARE"
  inst.components.fueled.ontakefuelfn = function() inst.SoundEmitter:PlaySound("dontstarve/common/nightmareAddFuel") onfuelupdate(inst) end
  inst.components.fueled:SetDepletedFn(
    function() FackSword(inst) end)
  inst.components.fueled:SetUpdateFn(onfuelupdate)
  inst.components.fueled:InitializeFuelLevel(240)

  inst.components.equippable.dapperness = -1/3

  inst:AddComponent("dapperness")
  inst.components.dapperness.dapperness = -1/3

  onfuelupdate(inst)

  -- if inst.components.moisture or inst.components.poisonable then
  --   inst.components.equippable.dapperness = -10
  -- else
  --   inst:AddComponent("dapperness")
  --   inst.components.dapperness.dapperness = -10
  -- end

  -- update(inst)

  -- inst.OnSave = onsave
  -- inst.OnLoad = onload
  -- inst.OnPreLoad = onload
  return inst
end

if TUNING.LANGA == 0 then
  STRINGS.NAMES.REALNIGHTSWORD = "黑莲"
  STRINGS.RECIPE_DESC.REALNIGHTSWORD = "在黑暗中绽放光芒"
  STRINGS.CHARACTERS.GENERIC.DESCRIBE.REALNIGHTSWORD = "这是真实存在的吗？"
else
  STRINGS.NAMES.REALNIGHTSWORD = "Black Lotus"
  STRINGS.RECIPE_DESC.REALNIGHTSWORD = "Shine in the darkness."
  STRINGS.CHARACTERS.GENERIC.DESCRIBE.REALNIGHTSWORD = "Is it real?"
end

return Prefab("realnightsword", fn, assets)